#! /usr/bin/wish


proc initui {} {
    global speed
    set speed 1

    frame .fLST
    set em {}
    set stuff "-bd 3"
    lappend em [eval label .fLST.lstlab $stuff -text "LST"]
    lappend em [eval entry .fLST.lste $stuff -width 6 -textvariable LST]
    lappend em [eval scale .fLST.lst $stuff -from -4 -to 28  -resolution .08333 -showvalue 0 \
		-orient horizontal -variable LST -command {{runanim 0; lst}}] 
    lappend em [eval label  .fLST.latlab $stuff -text "Latitude"]
    lappend em [eval entry  .fLST.late $stuff -width 6 -textvariable LAT]
    lappend em [eval scale  .fLST.lat $stuff -from -90 -to 90 -orient horizontal -variable LAT -showvalue 0 -command {lat}]
    packgroup $em {-side left -anchor w -pady 4}
    pack configure .fLST.lst -fill x -expand 1

    bind .fLST.lste <Return> {retfm}
    bind .fLST.late <Return> {retfm}

    frame .fANIM
    set em {}
    lappend em [eval button .fANIM.anim $stuff -text "Anim" -command {{toggle .fANIM.anim runanim}}]
    lappend em [eval label  .fANIM.slab $stuff -text "Speed"]
    lappend em [eval scale  .fANIM.speed $stuff -orient horizontal -showvalue 1 -variable speed -from -2 -to 2 -resolution .001]
    packgroup $em {-side left -anchor w -pady 4}
    pack configure .fANIM.speed -fill x -expand 1

    frame .cal
    set em {}
    lappend em [eval button .cal.spring $stuff -text Spring -command {{season .cal.spring {8 18}}}]
    lappend em [eval button .cal.summer $stuff -text Summer -command {{season .cal.summer {14 22}}}]
    lappend em [eval button .cal.autumn $stuff -text Autumn -command {{season .cal.autumn {19 5}}}]
    lappend em [eval button .cal.winter $stuff -text Winter -command {{season .cal.winter {0 13}}}]
    lappend em [eval label .cal.blank -text {{   }}]
    lappend em [eval checkbutton .cal.morning $stuff -text Morning -variable morning -textvariable morninglabel -command daytime]
    packgroup $em {-side left -anchor w -pady 4}

    frame .view
    set em {}
    lappend em [eval button .cal.east -text East  -command {{view east}}]
    lappend em [eval button .cal.west -text West  -command {{view west}}]
    lappend em [eval button .cal.north -text North  -command {{view north}}]
    packgroup $em {-side left -anchor w -pady 4}

    frame .tog
    set em {}
    lappend em [eval button .tog.horiz $stuff -text "Horizon" -command {{toggle .tog.horiz "turn g1"}}]
    lappend em [eval button .tog.near $stuff -text "Near" -command {{toggle .tog.near  near}}]

    lappend em [eval button .tog.gal $stuff -text "Galactic" -command {{toggle .tog.gal "turn g5"}}]
    lappend em [eval button .tog.ecl $stuff -text "Ecliptic" -command {{toggle .tog.ecl "turn g4"}}]
    lappend em [eval button .tog.stars $stuff -text "Stars" -command {{toggle .tog.stars "turn g3"}}]
    lappend em [eval button .tog.eqc $stuff -text "EqCirc" -command {{toggle .tog.eqc "turn {g2 eval point}"}}]
    lappend em [eval button .tog.eqh $stuff -text "EqHours" -command {{toggle .tog.eqh "turn {g2 eval label}"}}]
    packgroup $em {-side left -anchor w}

    packgroup {.tog .view .fLST .cal} {-side top -anchor w -fill both -expand 1}
}

set pi 3.1415926535
set LST 5.0
set LAT 40
set lastLST -9999
set lastLAT -9999

proc lst {LSTime} {
  global LST LAT
  set LST $LSTime
  retfm
}

proc lat {Latitude} {
  set LAT $Latitude
  retfm
}

set seasontimes {8 18}
proc season {button evemorn args} {
    global seasontimes
    toggle $button
    if {$button != ".cal.spring"} {.cal.spring config -relief raised}
    if {$button != ".cal.summer"} {.cal.summer config -relief raised}
    if {$button != ".cal.autumn"} {.cal.autumn config -relief raised}
    if {$button != ".cal.winter"} {.cal.winter config -relief raised}
    set seasontimes $evemorn
puts "# seasontimes $seasontimes"
    daytime
}

set morning 1
set morninglabel "Morning"
proc daytime {args} {
    global morning seasontimes morninglabel
    lst [lindex $seasontimes $morning]
    if {$morning} {
	set morninglabel "Morning"
    } else {
	set morninglabel "Evening"
    } 
}

proc retfm {} {
  global LST LAT lastLST lastLAT

  if {$LST < 0} {set LST [expr $LST + 24]}
  if {$LST > 24} {set LST [expr $LST - 24]}

  if {$LST == $lastLST && $LAT == $lastLAT} {
    return
  }
  set lastLST $LST
  set lastLAT $LAT

  set t1 [rotation z [expr 270-15*$LST]]
  set t2 [rotation x [expr $LAT-90]]
  set Tea [mmmul $t1 $t2]
  ## set Tae [transpose $Tea]

  say "{"
  say "g1 add tfm 1"
  say "g2 add tfm $Tea"
  say "g3 add tfm $Tea"

  set Tze {1 0 0 0 0.91748200036 0.39777729827 0 -0.39777729827 0.91748200036}
  set Tge {-0.054875539726 -0.87343710801 -0.48383498581 0.49410945331 -0.44482958943 0.74698225181 -0.86766613586 -0.19807638612 0.4559837957}

  set Tza [mmmul $Tze $Tea]
  set Tga [mmmul $Tge $Tea]
  say "g4 add tfm $Tza"
  say "g5 add tfm $Tga"
  say "}"
}

proc view {name} {
  case $name in \
    east { say "jump 7.97646 0.338692 2.58496  -2.24259 73.8298 90.7807" } \
    west { say "jump -8.0225 0.0762714 2.46055  -1.10001 -74.9695 -90.1552" } \
    north { say "jump -1.06601 6.41376 5.30546  -52.4738 -12.275 -160.2" }
} 

proc runanim {onoff} {
  global running
  set running $onoff

  retfm
}

proc toggle {win {func {}}} {
  set turnon [expr [string compare [$win cget -relief] sunken]!=0]
  $win configure -relief [lindex {raised sunken} $turnon]
  if {$func != ""} {
        eval $func $turnon
  }
}

proc packgroup {opts also} {
  set stuff {}
  set beware [expr [winfo depth .]==2]	;# Mouse-X (for NeXT) with server bug!
  for {set i 0} {$i < [llength $opts]} {incr i} {
	set this [lindex $opts $i]
	if {[string match .* $this]} {
	  if {$beware && [winfo class $this]=="Button" && [$this cget -relief]!="flat"} {
	    global Orr_repair
	    append Orr_repair "$this config -relief [$this cget -relief];"
	    $this config -relief flat
	  }
	  if {$stuff != ""} {
		eval pack $stuff $also
	  }
	  set stuff $this
	} else {
	  lappend stuff $this [lindex $opts [incr i]]
	}
  }
  if {$stuff != ""} {
	eval pack $stuff $also
  }
}

proc vmmul {v M} {
  set x [lindex $v 0]; set y [lindex $v 1]; set z [lindex $v 2]
  list [expr $x*[lindex $M 0]+$y*[lindex $M 3]+$z*[lindex $M 6]] \
	[expr $x*[lindex $M 1]+$y*[lindex $M 4]+$z*[lindex $M 7]] \
	[expr $x*[lindex $M 2]+$y*[lindex $M 5]+$z*[lindex $M 8]]
}

proc mmmul {A B} {
  concat \
	[vmmul [lrange $A 0 2] $B] \
	[vmmul [lrange $A 3 5] $B] \
	[vmmul [lrange $A 6 8] $B]
}

proc rotation {axis degrees} {
  global pi
  set rad [expr $degrees*$pi/180]
  set c [expr cos($rad)]
  set s [expr sin($rad)]
  set ms [expr -$s]
  if {$axis == "x"} {		list 1 0 0  0 $c $s  0 $ms $c
  } elseif {$axis == "y"} {	list $c 0 $ms  0 1 0  $s 0 $c
  } elseif {$axis == "z"} {	list $c $s 0  $ms $c 0  0 0 1
  } else {
	puts stderr "Can't rotate about axis $axis: must be 'x' or 'y' or 'z'"
  }
}

proc transpose {T} {
  set n [expr int(sqrt([llength $T]))]
  for {set i 0} {$i < $n} {incr i} {
    for {set j 0} {$j < $n} {incr j} {
	lappend U [lindex $T [expr $i+($j*$n)]]
    }
  }
  set U
}

proc threematrix {T} {
  concat [lrange $T 0 2] [lrange $T 4 6] [lrange $T 8 10]
}

proc fourmatrix {{T ""} {trans ""}} {
  if {$T != ""} {
	if {$trans != ""} {
	  concat [lrange $T 0 2] 0 [lrange $T 3 5] 0 [lrange $T 6 8] 0 $trans 1
	} else {
	  concat [lrange $T 0 2] 0 [lrange $T 3 5] 0 [lrange $T 6 8] 0 0 0 0 1
	}
  } else {
	set tr $trans
	if {$tr == ""} {set tr "0 0 0"}
	concat 1 0 0 0 0 1 0 0 0 0 1 0 $tr 1
  }
}

proc near {{onoff 0}} {
  if {$onoff == 0} {
	say "clip . 50"
  } else {
	say "clip . 7.7"
  }
}

proc turn {head rest} {
  if {$rest == 1} {
	set onoff "on"
  } else {
	set onoff "off"
  }
  say "$head $onoff"
}

proc say {what} {
  puts $what
  flush stdout
}

initui
